Index: /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modvariables.F90
===================================================================
--- /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modvariables.F90	(revision 10086)
+++ /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modvariables.F90	(revision 10087)
@@ -5,4 +5,16 @@
     implicit none
 !
+#if defined AGRIF_MPI
+    interface
+        subroutine Agrif_InvLoc ( indloc, proc_id, dir, indglob )
+            integer, intent(in)     :: indloc   !< local index
+            integer, intent(in)     :: proc_id  !< rank of the proc calling this function
+            integer, intent(in)     :: dir      !< direction of the index
+            integer, intent(out)    :: indglob  !< global index
+        end subroutine Agrif_InvLoc
+    end interface
+    private :: Agrif_InvLoc
+#endif
+
 contains
 !
@@ -14,18 +26,24 @@
 subroutine Agrif_Declare_Variable ( posvar, firstpoint, raf, lb, ub, varid, torestore )
 !---------------------------------------------------------------------------------------------------
-    integer,      dimension(:), intent(in)  :: posvar     !< position of the variable on the cell
-                                                          !! (1 for the border of the edge, 2 for the center)
-    integer,      dimension(:), intent(in)  :: firstpoint !< index of the first point in the real domain
-    character(1), dimension(:), intent(in)  :: raf        !< Array indicating the type of dimension (space or not)
-                                                          !!   for each of them
-    integer,      dimension(:), intent(in)  :: lb         !< Lower bounds of the array
-    integer,      dimension(:), intent(in)  :: ub         !< Upper bounds of the array
-    integer,                    intent(out) :: varid      !< Id number of the newly created variable
-    logical,      optional,     intent(in)  :: torestore  !< Indicates if the array restore is used
-!---------------------------------------------------------------------------------------------------
+    integer, dimension(:),      intent(in)      :: posvar     !< position of the variable on the cell
+                                                              !< (1 for the border of the edge, 2 for the center)
+    integer, dimension(:),      intent(in)      :: firstpoint !< index of the first point in the real domain
+    character(*), dimension(:), intent(in)      :: raf        !< Array indicating the type of dimension (space or not)
+                                                              !<   for each of them
+    integer, dimension(:),      intent(in)      :: lb         !< Lower bounds of the array
+    integer, dimension(:),      intent(in)      :: ub         !< Upper bounds of the array
+    integer,                    intent(out)     :: varid      !< Id number of the newly created variable
+    logical, optional,          intent(in)      :: torestore  !< Indicates if the array restore is used
+!
     type(Agrif_Variables_List), pointer :: new_varlist
     type(Agrif_Variable),       pointer :: var
-    integer                             :: nbdim, i
+    integer                             :: nbdim
     logical                             :: restore
+#if defined AGRIF_MPI
+    include 'mpif.h'
+    integer :: i
+    integer,dimension(6,2) :: iminmaxg, lubglob
+    integer :: code
+#endif
 
     restore = .FALSE.
@@ -43,24 +61,29 @@
     allocate(var % posvar(nbdim))
     allocate(var % interptab(nbdim))
-    allocate(var % coords(nbdim))
 !
-    var % nbdim          = nbdim
-    var % interptab      = raf(1:nbdim)
-    var % posvar         = posvar(1:nbdim)
-    var % point(1:nbdim) = firstpoint(1:nbdim)
+    var % interptab = raf
+    var % nbdim = nbdim
+    var % posvar = posvar
+    var % point(1:nbdim) = firstpoint
     var % restore = restore
-!
+
+    var % lb(1:nbdim) = lb(1:nbdim)
+    var % ub(1:nbdim) = ub(1:nbdim)
+
+#if defined AGRIF_MPI
     do i = 1,nbdim
-        select case( raf(i) )
-            case('x')    ; var % coords(i) = 1
-            case('y')    ; var % coords(i) = 2
-            case('z')    ; var % coords(i) = 3
-            case('N')    ; var % coords(i) = 0
-            case default ; var % coords(i) = 0
-        end select
+        call Agrif_Invloc(lb(i), Agrif_Procrank, i, iminmaxg(i,1))
+        call Agrif_Invloc(ub(i), Agrif_Procrank, i, iminmaxg(i,2))
     enddo
 !
-    var % lb(1:nbdim) = lb(1:nbdim)
-    var % ub(1:nbdim) = ub(1:nbdim)
+    iminmaxg(1:nbdim,2) = - iminmaxg(1:nbdim,2)
+    call MPI_ALLREDUCE(iminmaxg(1:nbdim,:), lubglob(1:nbdim,:), 2*nbdim, MPI_INTEGER,MPI_MIN,Agrif_mpi_comm, code)
+    lubglob(1:nbdim,2)  = - lubglob(1:nbdim,2)
+    var % lbglob(1:nbdim) = lubglob(1:nbdim,1)
+    var % ubglob(1:nbdim) = lubglob(1:nbdim,2)
+#else
+    var % lbglob(1:nbdim) = var % lb(1:nbdim)
+    var % ubglob(1:nbdim) = var % ub(1:nbdim)
+#endif
 
     if ( restore ) then
@@ -121,5 +144,5 @@
     integer :: nb, varidinv
 !
-    if ( .not.associated(grid) ) then
+    if ( .not.associated(grid)) then
         outvar => NULL()
         return
@@ -127,10 +150,11 @@
 !
     parcours => grid % variables
-
+    
     if (.not. associated(parcours)) then   ! can occur on the grand mother grid
            outvar => NULL()                ! during the first call by agrif_mygrid
            return
     endif
-
+                                           
+    
     varidinv = 1 + grid % nbvariables - varid
 
@@ -140,4 +164,5 @@
 
     outvar => parcours % var
+
 !---------------------------------------------------------------------------------------------------
 end function Agrif_Search_variable
